<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Getpartners ServiceType
 * @subpackage Services
 */
class Getpartners extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named get_partners
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\Get_partners $parameters
     * @return \StructType\Get_partnersResponse|bool
     */
    public function get_partners(\StructType\Get_partners $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->get_partners($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\Get_partnersResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
