<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for airtime_trans_log StructType
 * @subpackage Structs
 */
class Airtime_trans_log extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credential
     */
    public $login;
    /**
     * The send_amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Money
     */
    public $send_amount;
    /**
     * The fee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Money
     */
    public $fee;
    /**
     * The receive_amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Money
     */
    public $receive_amount;
    /**
     * The recipient
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $recipient;
    /**
     * The sender
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $sender;
    /**
     * The reference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $reference;
    /**
     * The third_party_trans_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $third_party_trans_id;
    /**
     * The airtime_mno_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $airtime_mno_id;
    /**
     * Constructor method for airtime_trans_log
     * @uses Airtime_trans_log::setLogin()
     * @uses Airtime_trans_log::setSend_amount()
     * @uses Airtime_trans_log::setFee()
     * @uses Airtime_trans_log::setReceive_amount()
     * @uses Airtime_trans_log::setRecipient()
     * @uses Airtime_trans_log::setSender()
     * @uses Airtime_trans_log::setReference()
     * @uses Airtime_trans_log::setThird_party_trans_id()
     * @uses Airtime_trans_log::setAirtime_mno_id()
     * @param \StructType\Credential $login
     * @param \StructType\Money $send_amount
     * @param \StructType\Money $fee
     * @param \StructType\Money $receive_amount
     * @param string $recipient
     * @param string $sender
     * @param string $reference
     * @param string $third_party_trans_id
     * @param string $airtime_mno_id
     */
    public function __construct(\StructType\Credential $login = null, \StructType\Money $send_amount = null, \StructType\Money $fee = null, \StructType\Money $receive_amount = null, $recipient = null, $sender = null, $reference = null, $third_party_trans_id = null, $airtime_mno_id = null)
    {
        $this
            ->setLogin($login)
            ->setSend_amount($send_amount)
            ->setFee($fee)
            ->setReceive_amount($receive_amount)
            ->setRecipient($recipient)
            ->setSender($sender)
            ->setReference($reference)
            ->setThird_party_trans_id($third_party_trans_id)
            ->setAirtime_mno_id($airtime_mno_id);
    }
    /**
     * Get login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credential|null
     */
    public function getLogin()
    {
        return isset($this->login) ? $this->login : null;
    }
    /**
     * Set login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credential $login
     * @return \StructType\Airtime_trans_log
     */
    public function setLogin(\StructType\Credential $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->login);
        } else {
            $this->login = $login;
        }
        return $this;
    }
    /**
     * Get send_amount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Money|null
     */
    public function getSend_amount()
    {
        return isset($this->send_amount) ? $this->send_amount : null;
    }
    /**
     * Set send_amount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Money $send_amount
     * @return \StructType\Airtime_trans_log
     */
    public function setSend_amount(\StructType\Money $send_amount = null)
    {
        if (is_null($send_amount) || (is_array($send_amount) && empty($send_amount))) {
            unset($this->send_amount);
        } else {
            $this->send_amount = $send_amount;
        }
        return $this;
    }
    /**
     * Get fee value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Money|null
     */
    public function getFee()
    {
        return isset($this->fee) ? $this->fee : null;
    }
    /**
     * Set fee value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Money $fee
     * @return \StructType\Airtime_trans_log
     */
    public function setFee(\StructType\Money $fee = null)
    {
        if (is_null($fee) || (is_array($fee) && empty($fee))) {
            unset($this->fee);
        } else {
            $this->fee = $fee;
        }
        return $this;
    }
    /**
     * Get receive_amount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Money|null
     */
    public function getReceive_amount()
    {
        return isset($this->receive_amount) ? $this->receive_amount : null;
    }
    /**
     * Set receive_amount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Money $receive_amount
     * @return \StructType\Airtime_trans_log
     */
    public function setReceive_amount(\StructType\Money $receive_amount = null)
    {
        if (is_null($receive_amount) || (is_array($receive_amount) && empty($receive_amount))) {
            unset($this->receive_amount);
        } else {
            $this->receive_amount = $receive_amount;
        }
        return $this;
    }
    /**
     * Get recipient value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRecipient()
    {
        return isset($this->recipient) ? $this->recipient : null;
    }
    /**
     * Set recipient value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $recipient
     * @return \StructType\Airtime_trans_log
     */
    public function setRecipient($recipient = null)
    {
        // validation for constraint: string
        if (!is_null($recipient) && !is_string($recipient)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recipient, true), gettype($recipient)), __LINE__);
        }
        if (is_null($recipient) || (is_array($recipient) && empty($recipient))) {
            unset($this->recipient);
        } else {
            $this->recipient = $recipient;
        }
        return $this;
    }
    /**
     * Get sender value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSender()
    {
        return isset($this->sender) ? $this->sender : null;
    }
    /**
     * Set sender value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $sender
     * @return \StructType\Airtime_trans_log
     */
    public function setSender($sender = null)
    {
        // validation for constraint: string
        if (!is_null($sender) && !is_string($sender)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sender, true), gettype($sender)), __LINE__);
        }
        if (is_null($sender) || (is_array($sender) && empty($sender))) {
            unset($this->sender);
        } else {
            $this->sender = $sender;
        }
        return $this;
    }
    /**
     * Get reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReference()
    {
        return isset($this->reference) ? $this->reference : null;
    }
    /**
     * Set reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reference
     * @return \StructType\Airtime_trans_log
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference, true), gettype($reference)), __LINE__);
        }
        if (is_null($reference) || (is_array($reference) && empty($reference))) {
            unset($this->reference);
        } else {
            $this->reference = $reference;
        }
        return $this;
    }
    /**
     * Get third_party_trans_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getThird_party_trans_id()
    {
        return isset($this->third_party_trans_id) ? $this->third_party_trans_id : null;
    }
    /**
     * Set third_party_trans_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $third_party_trans_id
     * @return \StructType\Airtime_trans_log
     */
    public function setThird_party_trans_id($third_party_trans_id = null)
    {
        // validation for constraint: string
        if (!is_null($third_party_trans_id) && !is_string($third_party_trans_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($third_party_trans_id, true), gettype($third_party_trans_id)), __LINE__);
        }
        if (is_null($third_party_trans_id) || (is_array($third_party_trans_id) && empty($third_party_trans_id))) {
            unset($this->third_party_trans_id);
        } else {
            $this->third_party_trans_id = $third_party_trans_id;
        }
        return $this;
    }
    /**
     * Get airtime_mno_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAirtime_mno_id()
    {
        return isset($this->airtime_mno_id) ? $this->airtime_mno_id : null;
    }
    /**
     * Set airtime_mno_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $airtime_mno_id
     * @return \StructType\Airtime_trans_log
     */
    public function setAirtime_mno_id($airtime_mno_id = null)
    {
        // validation for constraint: string
        if (!is_null($airtime_mno_id) && !is_string($airtime_mno_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airtime_mno_id, true), gettype($airtime_mno_id)), __LINE__);
        }
        if (is_null($airtime_mno_id) || (is_array($airtime_mno_id) && empty($airtime_mno_id))) {
            unset($this->airtime_mno_id);
        } else {
            $this->airtime_mno_id = $airtime_mno_id;
        }
        return $this;
    }
}
