<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bank_remit_log StructType
 * @subpackage Structs
 */
class Bank_remit_log extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credential
     */
    public $login;
    /**
     * The receive_amount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Money
     */
    public $receive_amount;
    /**
     * The sender
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Sender
     */
    public $sender;
    /**
     * The recipient
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Recipient
     */
    public $recipient;
    /**
     * The account
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Account
     */
    public $account;
    /**
     * The third_party_trans_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $third_party_trans_id;
    /**
     * The reference
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $reference;
    /**
     * Constructor method for bank_remit_log
     * @uses Bank_remit_log::setLogin()
     * @uses Bank_remit_log::setReceive_amount()
     * @uses Bank_remit_log::setSender()
     * @uses Bank_remit_log::setRecipient()
     * @uses Bank_remit_log::setAccount()
     * @uses Bank_remit_log::setThird_party_trans_id()
     * @uses Bank_remit_log::setReference()
     * @param \StructType\Credential $login
     * @param \StructType\Money $receive_amount
     * @param \StructType\Sender $sender
     * @param \StructType\Recipient $recipient
     * @param \StructType\Account $account
     * @param string $third_party_trans_id
     * @param string $reference
     */
    public function __construct(\StructType\Credential $login = null, \StructType\Money $receive_amount = null, \StructType\Sender $sender = null, \StructType\Recipient $recipient = null, \StructType\Account $account = null, $third_party_trans_id = null, $reference = null)
    {
        $this
            ->setLogin($login)
            ->setReceive_amount($receive_amount)
            ->setSender($sender)
            ->setRecipient($recipient)
            ->setAccount($account)
            ->setThird_party_trans_id($third_party_trans_id)
            ->setReference($reference);
    }
    /**
     * Get login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credential|null
     */
    public function getLogin()
    {
        return isset($this->login) ? $this->login : null;
    }
    /**
     * Set login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credential $login
     * @return \StructType\Bank_remit_log
     */
    public function setLogin(\StructType\Credential $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->login);
        } else {
            $this->login = $login;
        }
        return $this;
    }
    /**
     * Get receive_amount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Money|null
     */
    public function getReceive_amount()
    {
        return isset($this->receive_amount) ? $this->receive_amount : null;
    }
    /**
     * Set receive_amount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Money $receive_amount
     * @return \StructType\Bank_remit_log
     */
    public function setReceive_amount(\StructType\Money $receive_amount = null)
    {
        if (is_null($receive_amount) || (is_array($receive_amount) && empty($receive_amount))) {
            unset($this->receive_amount);
        } else {
            $this->receive_amount = $receive_amount;
        }
        return $this;
    }
    /**
     * Get sender value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Sender|null
     */
    public function getSender()
    {
        return isset($this->sender) ? $this->sender : null;
    }
    /**
     * Set sender value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Sender $sender
     * @return \StructType\Bank_remit_log
     */
    public function setSender(\StructType\Sender $sender = null)
    {
        if (is_null($sender) || (is_array($sender) && empty($sender))) {
            unset($this->sender);
        } else {
            $this->sender = $sender;
        }
        return $this;
    }
    /**
     * Get recipient value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Recipient|null
     */
    public function getRecipient()
    {
        return isset($this->recipient) ? $this->recipient : null;
    }
    /**
     * Set recipient value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Recipient $recipient
     * @return \StructType\Bank_remit_log
     */
    public function setRecipient(\StructType\Recipient $recipient = null)
    {
        if (is_null($recipient) || (is_array($recipient) && empty($recipient))) {
            unset($this->recipient);
        } else {
            $this->recipient = $recipient;
        }
        return $this;
    }
    /**
     * Get account value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Account|null
     */
    public function getAccount()
    {
        return isset($this->account) ? $this->account : null;
    }
    /**
     * Set account value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Account $account
     * @return \StructType\Bank_remit_log
     */
    public function setAccount(\StructType\Account $account = null)
    {
        if (is_null($account) || (is_array($account) && empty($account))) {
            unset($this->account);
        } else {
            $this->account = $account;
        }
        return $this;
    }
    /**
     * Get third_party_trans_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getThird_party_trans_id()
    {
        return isset($this->third_party_trans_id) ? $this->third_party_trans_id : null;
    }
    /**
     * Set third_party_trans_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $third_party_trans_id
     * @return \StructType\Bank_remit_log
     */
    public function setThird_party_trans_id($third_party_trans_id = null)
    {
        // validation for constraint: string
        if (!is_null($third_party_trans_id) && !is_string($third_party_trans_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($third_party_trans_id, true), gettype($third_party_trans_id)), __LINE__);
        }
        if (is_null($third_party_trans_id) || (is_array($third_party_trans_id) && empty($third_party_trans_id))) {
            unset($this->third_party_trans_id);
        } else {
            $this->third_party_trans_id = $third_party_trans_id;
        }
        return $this;
    }
    /**
     * Get reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReference()
    {
        return isset($this->reference) ? $this->reference : null;
    }
    /**
     * Set reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reference
     * @return \StructType\Bank_remit_log
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reference, true), gettype($reference)), __LINE__);
        }
        if (is_null($reference) || (is_array($reference) && empty($reference))) {
            unset($this->reference);
        } else {
            $this->reference = $reference;
        }
        return $this;
    }
}
