<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cancel_voucher StructType
 * @subpackage Structs
 */
class Cancel_voucher extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credential
     */
    public $login;
    /**
     * The mfs_trans_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mfs_trans_id;
    /**
     * The third_party_trans_id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $third_party_trans_id;
    /**
     * The voucher_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $voucher_code;
    /**
     * The voucher_partner
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $voucher_partner;
    /**
     * Constructor method for cancel_voucher
     * @uses Cancel_voucher::setLogin()
     * @uses Cancel_voucher::setMfs_trans_id()
     * @uses Cancel_voucher::setThird_party_trans_id()
     * @uses Cancel_voucher::setVoucher_code()
     * @uses Cancel_voucher::setVoucher_partner()
     * @param \StructType\Credential $login
     * @param string $mfs_trans_id
     * @param string $third_party_trans_id
     * @param string $voucher_code
     * @param string $voucher_partner
     */
    public function __construct(\StructType\Credential $login = null, $mfs_trans_id = null, $third_party_trans_id = null, $voucher_code = null, $voucher_partner = null)
    {
        $this
            ->setLogin($login)
            ->setMfs_trans_id($mfs_trans_id)
            ->setThird_party_trans_id($third_party_trans_id)
            ->setVoucher_code($voucher_code)
            ->setVoucher_partner($voucher_partner);
    }
    /**
     * Get login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credential|null
     */
    public function getLogin()
    {
        return isset($this->login) ? $this->login : null;
    }
    /**
     * Set login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credential $login
     * @return \StructType\Cancel_voucher
     */
    public function setLogin(\StructType\Credential $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->login);
        } else {
            $this->login = $login;
        }
        return $this;
    }
    /**
     * Get mfs_trans_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMfs_trans_id()
    {
        return isset($this->mfs_trans_id) ? $this->mfs_trans_id : null;
    }
    /**
     * Set mfs_trans_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mfs_trans_id
     * @return \StructType\Cancel_voucher
     */
    public function setMfs_trans_id($mfs_trans_id = null)
    {
        // validation for constraint: string
        if (!is_null($mfs_trans_id) && !is_string($mfs_trans_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mfs_trans_id, true), gettype($mfs_trans_id)), __LINE__);
        }
        if (is_null($mfs_trans_id) || (is_array($mfs_trans_id) && empty($mfs_trans_id))) {
            unset($this->mfs_trans_id);
        } else {
            $this->mfs_trans_id = $mfs_trans_id;
        }
        return $this;
    }
    /**
     * Get third_party_trans_id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getThird_party_trans_id()
    {
        return isset($this->third_party_trans_id) ? $this->third_party_trans_id : null;
    }
    /**
     * Set third_party_trans_id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $third_party_trans_id
     * @return \StructType\Cancel_voucher
     */
    public function setThird_party_trans_id($third_party_trans_id = null)
    {
        // validation for constraint: string
        if (!is_null($third_party_trans_id) && !is_string($third_party_trans_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($third_party_trans_id, true), gettype($third_party_trans_id)), __LINE__);
        }
        if (is_null($third_party_trans_id) || (is_array($third_party_trans_id) && empty($third_party_trans_id))) {
            unset($this->third_party_trans_id);
        } else {
            $this->third_party_trans_id = $third_party_trans_id;
        }
        return $this;
    }
    /**
     * Get voucher_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVoucher_code()
    {
        return isset($this->voucher_code) ? $this->voucher_code : null;
    }
    /**
     * Set voucher_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $voucher_code
     * @return \StructType\Cancel_voucher
     */
    public function setVoucher_code($voucher_code = null)
    {
        // validation for constraint: string
        if (!is_null($voucher_code) && !is_string($voucher_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($voucher_code, true), gettype($voucher_code)), __LINE__);
        }
        if (is_null($voucher_code) || (is_array($voucher_code) && empty($voucher_code))) {
            unset($this->voucher_code);
        } else {
            $this->voucher_code = $voucher_code;
        }
        return $this;
    }
    /**
     * Get voucher_partner value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVoucher_partner()
    {
        return isset($this->voucher_partner) ? $this->voucher_partner : null;
    }
    /**
     * Set voucher_partner value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $voucher_partner
     * @return \StructType\Cancel_voucher
     */
    public function setVoucher_partner($voucher_partner = null)
    {
        // validation for constraint: string
        if (!is_null($voucher_partner) && !is_string($voucher_partner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($voucher_partner, true), gettype($voucher_partner)), __LINE__);
        }
        if (is_null($voucher_partner) || (is_array($voucher_partner) && empty($voucher_partner))) {
            unset($this->voucher_partner);
        } else {
            $this->voucher_partner = $voucher_partner;
        }
        return $this;
    }
}
