<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for validate_airtime_account StructType
 * @subpackage Structs
 */
class Validate_airtime_account extends AbstractStructBase
{
    /**
     * The login
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credential
     */
    public $login;
    /**
     * The from_country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $from_country;
    /**
     * The send_currency_code
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $send_currency_code;
    /**
     * The to_country
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $to_country;
    /**
     * The msisdn
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $msisdn;
    /**
     * Constructor method for validate_airtime_account
     * @uses Validate_airtime_account::setLogin()
     * @uses Validate_airtime_account::setFrom_country()
     * @uses Validate_airtime_account::setSend_currency_code()
     * @uses Validate_airtime_account::setTo_country()
     * @uses Validate_airtime_account::setMsisdn()
     * @param \StructType\Credential $login
     * @param string $from_country
     * @param string $send_currency_code
     * @param string $to_country
     * @param string $msisdn
     */
    public function __construct(\StructType\Credential $login = null, $from_country = null, $send_currency_code = null, $to_country = null, $msisdn = null)
    {
        $this
            ->setLogin($login)
            ->setFrom_country($from_country)
            ->setSend_currency_code($send_currency_code)
            ->setTo_country($to_country)
            ->setMsisdn($msisdn);
    }
    /**
     * Get login value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credential|null
     */
    public function getLogin()
    {
        return isset($this->login) ? $this->login : null;
    }
    /**
     * Set login value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credential $login
     * @return \StructType\Validate_airtime_account
     */
    public function setLogin(\StructType\Credential $login = null)
    {
        if (is_null($login) || (is_array($login) && empty($login))) {
            unset($this->login);
        } else {
            $this->login = $login;
        }
        return $this;
    }
    /**
     * Get from_country value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFrom_country()
    {
        return isset($this->from_country) ? $this->from_country : null;
    }
    /**
     * Set from_country value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $from_country
     * @return \StructType\Validate_airtime_account
     */
    public function setFrom_country($from_country = null)
    {
        // validation for constraint: string
        if (!is_null($from_country) && !is_string($from_country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($from_country, true), gettype($from_country)), __LINE__);
        }
        if (is_null($from_country) || (is_array($from_country) && empty($from_country))) {
            unset($this->from_country);
        } else {
            $this->from_country = $from_country;
        }
        return $this;
    }
    /**
     * Get send_currency_code value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSend_currency_code()
    {
        return isset($this->send_currency_code) ? $this->send_currency_code : null;
    }
    /**
     * Set send_currency_code value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $send_currency_code
     * @return \StructType\Validate_airtime_account
     */
    public function setSend_currency_code($send_currency_code = null)
    {
        // validation for constraint: string
        if (!is_null($send_currency_code) && !is_string($send_currency_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($send_currency_code, true), gettype($send_currency_code)), __LINE__);
        }
        if (is_null($send_currency_code) || (is_array($send_currency_code) && empty($send_currency_code))) {
            unset($this->send_currency_code);
        } else {
            $this->send_currency_code = $send_currency_code;
        }
        return $this;
    }
    /**
     * Get to_country value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTo_country()
    {
        return isset($this->to_country) ? $this->to_country : null;
    }
    /**
     * Set to_country value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $to_country
     * @return \StructType\Validate_airtime_account
     */
    public function setTo_country($to_country = null)
    {
        // validation for constraint: string
        if (!is_null($to_country) && !is_string($to_country)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($to_country, true), gettype($to_country)), __LINE__);
        }
        if (is_null($to_country) || (is_array($to_country) && empty($to_country))) {
            unset($this->to_country);
        } else {
            $this->to_country = $to_country;
        }
        return $this;
    }
    /**
     * Get msisdn value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMsisdn()
    {
        return isset($this->msisdn) ? $this->msisdn : null;
    }
    /**
     * Set msisdn value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $msisdn
     * @return \StructType\Validate_airtime_account
     */
    public function setMsisdn($msisdn = null)
    {
        // validation for constraint: string
        if (!is_null($msisdn) && !is_string($msisdn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($msisdn, true), gettype($msisdn)), __LINE__);
        }
        if (is_null($msisdn) || (is_array($msisdn) && empty($msisdn))) {
            unset($this->msisdn);
        } else {
            $this->msisdn = $msisdn;
        }
        return $this;
    }
}
